Subject: Basic Accessibility of the Neos Backend (step 1)
Description

Accessibility of the Neos Backend
    -  Target Audience: power users or people with disabilities who want to edit content using the keyboard or assistive devices like
screen readers
    -  Responsible: Rens Admiraal
    -  Implemented by: Rens Admiraal, Patrick Broens
    -  Amount: 20 work days
    -  Version: must have for 1.0
    -  Planned Implementation Timeframe: February till half-way april

Motivation
People with disabilities can have huge problems using webapplications. There are specifications available like WAI-ARIA which can
be used for enabling those people to use all features the Neos interface offers.
A power user is used to using keyboard shortcuts and navigation. As the WAI-ARIA specification already requires keyboard navigation
the power user will have a faster editing experience.

Goal
We aim for a backend, usable by all people, not limited by disabilities. It has to be compatible with assistive technology like
screenreaders. By having a smooth keyboard control the content editing will also be a lot faster for power users.
Besides implementation we aim for awareness by offering guidelines and documentation how other developer can develop modules in
Neos following the same principles so those will be accessible too.
In this work package we will implement the first steps needed to have an accessible backend.

Deliverables
    -  Add WAI-ARIA landmarks / roles for application, navigation, content and inspector
    -  Enable keyboard navigation trough content elements and the inspector (WAI-ARIA)
    -  Edit Content with Keyboard Shortcuts (general editing like copy, paste, cut, delete and create on content elements)
    -  Could have keyboard navigation in menubar and toolbar
    -  Could have: A clear help function in the for usage of this feature (like the overlay in for example gerrit or github)
    -  Keyboard mapping for cross-browser / OS compatibility (using a library like http://craig.is/killing/mice)
    -  Documentation of the feature, and documentation for other developers using / extending Neos
    -  Publications

Dont' haves
    -  Custom content editors like image editor / cropping are not supported

Subtasks:
Task # 48209: Move all content elements below 1 DOM element Resolved
Task # 48210: Restructure the bootstrap of the contentmodule to use ember Resolved
Task # 48243: Add Keyboard navigation / eventhandling class Resolved
Related issues:
related to Base Distribution - Work Package # 45024: [WIP] Context sensitive ... New 2013-05-16
related to Base Distribution - Task # 48211: Make the handles a 'singleton' Resolved 2013-05-15
related to Base Distribution - Task # 48242: Add WAI-Aria roles On Hold 2013-05-16
blocked by Base Distribution - Work Package # 47023: Global user interface Accepted 2013-02-13
http://forge.typo3.org/users/3198
http://craig.is/killing/mice


History
#1 - 2013-01-31 13:44 - Rens Admiraal
- Subject changed from [WIP] Basic Accessibility of the Neos Backend to [WIP] Basic Accessibility of the Neos Backend (step 1)

#2 - 2013-01-31 14:17 - Rens Admiraal
- Subject changed from [WIP] Basic Accessibility of the Neos Backend (step 1) to Basic Accessibility of the Neos Backend (step 1)

#3 - 2013-02-16 14:59 - Sebastian Kurfuerst
- Status changed from New to Accepted

#4 - 2013-02-16 15:07 - Sebastian Kurfuerst
- File typo3neos-distribution-base-45007.pdf added
- Due date set to 2013-04-15
- Start date changed from 2013-01-31 to 2013-02-18
- Estimated time set to 120.00

Has been discussed with Jan-Hendrik from the EAB on 12.02.2013; and has been accepted on 15.02.2013 by the EAB.
(The attached PDF is a snapshot of this work package at the time of acceptance.)

So, Rens and Patrick, you can schedule this work package in your day-to-day calendar and implement it then -- can't wait to see it in Neos 1.0 :-)

Another side-note: Please do not forget to add comments to this work package and update "% done" while you are working on this package.

Greets, Sebastian

#5 - 2013-05-16 10:16 - Rens Admiraal

We've done most of the preparation. Parts of the masterplan largely effect this workpackage so it's hard to give a hard deadline when we think it will be
done. If we continue like this and review the roles that should be added later on, then mostly the keyboard navigation needs to be tuned for now. Most
other changes are already under review or related to the restructuring we've done during the codesprint in Karlsruhe.

For now I would think the keyboard navigation and missing roles / context sensitive help can be added start of june, depending on the progress of
#47023.

#6 - 2013-10-22 22:09 - Rens Admiraal

A lot of work of this workpackage has been put into restructuring the Neos DOM and preparing Neos to be configurable with roles and full keyboard
navigation support. Besides that effort has been put into dividing the actual website from the Neos backend interface to prevent collissions in CSS and
further stability.

The keyboard navigation and WAI-ARIA roles still have to be extended and tuned, but with the current work done on the concept it's not possible to
get this in a final state. Basic keyboard navigation is merged now, and a help screen with explanation is under review.

The WAI-ARIA roles issue is still open and assigned to me, when the UX concepts have been finalized and implemented we'll take care of adding the
roles to Neos.
